#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n, k;
ll lg = 0;
vector<vector<ll>> g;
vector<vector<ll>> up;
vector<pair<ll, ll>> deeps;
vector<bool> blocked;

ll get_pred(ll v, ll x) {
    for (ll i = lg - 1; i >= 0; i--) {
        if ((1 << i) <= x) {
            v = up[i][v];
            x -= (1 << i);
        }
    }
    return v;
}

void count_bin_ups(ll v, ll p) {
    up[0][v] = p;
    for (auto &to: g[v]) {
        if (to != p) {
            count_bin_ups(to, v);
        }
    }
}

void count_deeps(ll v, ll p, ll d) {
    deeps.emplace_back(d, v);
    for (auto &to: g[v]) {
        if (to != p) {
            count_deeps(to, v, d + 1);
        }
    }
}

void block(ll v, ll p) {
    blocked[v] = true;
    for (auto &to: g[v]) {
        if (to != p && !blocked[to]) {
            block(to, v);
        }
    }
}

bool check(ll x) {
    blocked.assign(n, false);
    ll ind = 0;
    ll k1 = k;
    while (k1 > 0 && ind < n) {
        ll d = deeps[ind].first;
        ll v = deeps[ind].second;
        if (!blocked[v] && d > x) {
            ll u = get_pred(v, x - 1);
            k1--;
            block(u, up[0][u]);
        }
        ind++;
    }
    if (ind == n){
        return true;
    }
    while (blocked[deeps[ind].second]){
        ind++;
    }
    return deeps[ind].first<=x;
}

ll get(ll v) {
    up.assign(lg, vector<ll>(n));
    count_bin_ups(v, v);
    for (ll i = 1; i < lg; i++) {
        for (ll j = 0; j < n; j++) {
            up[i][j] = up[i - 1][up[i - 1][j]];
        }
    }
    deeps.clear();
    count_deeps(v, v, 0);
    sort(deeps.begin(), deeps.end());
    reverse(deeps.begin(), deeps.end());
    ll l = 0, r = n - 1;
    while (r - l > 1) {
        ll m = (l + r) / 2;
        if (check(m)) {
            r = m;
        } else {
            l = m;
        }
    }
    return r;
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll t;
    cin >> n >> k >> t;
    g.assign(n, {});
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    while ((1 << lg) <= n) {
        lg++;
    }
    if (t == 0) {
        cout << get(0);
    } else {
        for (ll i = 0; i < n; i++) {
            cout << get(i) << ' ';
        }
    }
}