#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct SegmentTree {
    vector<ll> tree;
    vector<ll> set;
    vector<bool> is_set;
    ll n;

    explicit SegmentTree(ll n) : n(n) {
        tree.assign(4 * n, 0);
        set.assign(4 * n, 0);
        is_set.assign(4 * n, false);
        build(0, 0, n);
    }

    void build(ll v, ll l, ll r) {
        if (l == r - 1) {
            tree[v] = 1;
            set[v] = -1;
            return;
        }
        ll m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    void push(ll v, ll l, ll r) {
        if (is_set[v]) {
            ll m = (l + r) / 2;
            tree[2 * v + 1] = set[v] == -1 ? (m - l) : 0;
            tree[2 * v + 2] = set[v] == -1 ? (r - m) : 0;
            set[2 * v + 1] = set[v];
            set[2 * v + 2] = set[v];
            is_set[2 * v + 1] = true;
            is_set[2 * v + 2] = true;
            is_set[v] = false;
        }
    }

    void update(ll v, ll l, ll r, ll ql, ll qr, ll val) {
        if (qr <= l || r <= ql) {
            return;
        }
        if (ql <= l && r <= qr) {
            tree[v] = val == -1 ? r - l : 0;
            set[v] = val;
            is_set[v] = true;
            return;
        }
        push(v, l, r);
        ll m = (l + r) / 2;
        update(2 * v + 1, l, m, ql, qr, val);
        update(2 * v + 2, m, r, ql, qr, val);
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    void update(ll ql, ll qr, ll val) {
        update(0, 0, n, ql, qr, val);
    }

    ll get(ll v, ll l, ll r, ll ind) {
        if (ind < l || r <= ind) {
            return 0;
        }
        if (l == r - 1) {
            return set[v];
        }
        push(v, l, r);
        ll m = (l + r) / 2;
        ll x = get(2 * v + 1, l, m, ind);
        ll y = get(2 * v + 2, m, r, ind);
        return x + y;
    }

    ll get(ll ind) {
        return get(0, 0, n, ind);
    }

    ll get_cnt(ll v, ll l, ll r, ll ql, ll qr) {
        if (qr <= l || r <= ql) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        push(v, l, r);
        ll m = (l + r) / 2;
        ll x = get_cnt(2 * v + 1, l, m, ql, qr);
        ll y = get_cnt(2 * v + 2, m, r, ql, qr);
        return x + y;
    }

    ll get_cnt(ll ql, ll qr) {
        return get_cnt(0, 0, n, ql, qr);
    }
};

ll n, q;
vector<pair<ll, ll>> g;
vector<ll> sz;
vector<ll> par;
vector<ll> type;

void dfs(ll v, ll p, ll t) {
    par[v] = p;
    sz[v] = 1;
    type[v] = t;
    if (g[v].first != -1) {
        dfs(g[v].first, v, 0);
        sz[v] += sz[g[v].first];
    }
    if (g[v].second != -1) {
        dfs(g[v].second, v, 1);
        sz[v] += sz[g[v].second];
    }
}

ll get_size(ll v) {
    if (v == -1) {
        return 0;
    } else {
        return sz[v];
    }
}

SegmentTree tree(1);
vector<ll> tree1;
vector<ll> o;
vector<ll> ans2;

void foo(ll v) {
    if (tree1[v] == -1) {
        o.push_back(v);
    }
    if (g[v].first != -1) {
        foo(g[v].first);
    }
    if (tree1[v] == 0) {
        o.push_back(v);
    }
    if (g[v].second != -1) {
        foo(g[v].second);
    }
    if (tree1[v] == 1) {
        o.push_back(v);
    }
}

void foo1() {
    foo(0);
    for (ll i = 0; i < n; i++) {
        ans2[o[i]] = i;
    }
}

void foo_1(ll v) {
    ll res = tree.get(v);
    if (res == -1) {
        o.push_back(v);
    }
    if (g[v].first != -1) {
        foo_1(g[v].first);
    }
    if (res == 0) {
        o.push_back(v);
    }
    if (g[v].second != -1) {
        foo_1(g[v].second);
    }
    if (res == 1) {
        o.push_back(v);
    }
}

void foo1_1() {
    foo_1(0);
    for (ll i = 0; i < n; i++) {
        ans2[o[i]] = i;
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> q;
    g = vector<pair<ll, ll>>(n);
    for (ll i = 0; i < n; i++) {
        cin >> g[i].first >> g[i].second;
        g[i].first--;
        g[i].second--;
    }
    sz.assign(n, 0);
    par.assign(n, -1);
    type.assign(n, 0);
    dfs(0, -1, 0);
    vector<vector<ll>> queries(q);
    ll q1 = 0;
    ll last1 = q, first2 = -1;
    for (ll i = 0; i < q; i++) {
        ll t;
        cin >> t;
        if (t == 1) {
            ll l, r, x;
            cin >> l >> r >> x;
            l--;
            queries[i] = {t, l, r, x};
            q1++;
            last1 = i;
        } else {
            ll v;
            cin >> v;
            v--;
            queries[i] = {t, v};
            if (first2 == -1) {
                first2 = i;
            }
        }
    }
    if (last1 < first2) {
        tree = SegmentTree(n);
        ans2.assign(n, -1);
        for (ll i = 0; i < q; i++) {
            vector<ll> query = queries[i];
            if (i == first2) {
                foo1_1();
            }
            ll t = query[0];
            if (t == 1) {
                ll l = query[1], r = query[2], x = query[3];
                tree.update(l, r, x);
            } else {
                ll v = query[1];
                cout << ans2[v] + 1 << '\n';
            }
        }
    } else if (q1 <= 10) {
        tree1.assign(n, -1);
        ans2.assign(n, -1);
        foo1();
        for (auto &query: queries) {
            ll t = query[0];
            if (t == 1) {
                ll l = query[1], r = query[2], x = query[3];
                for (ll i = l; i < r; i++) {
                    tree1[i] = x;
                }
                o.clear();
                foo1();
            } else {
                ll v = query[1];
                cout << ans2[v] + 1 << '\n';
            }
        }
    } else {
        tree1.assign(n, -1);
        for (auto &query: queries) {
            ll t = query[0];
            if (t == 1) {
                ll l = query[1], r = query[2], x = query[3];
                for (ll i = l; i < r; i++) {
                    tree1[i] = x;
                }
            } else {
                ll v = query[1];
                ll ans;
                ll res = tree1[v];
                if (res == -1) {
                    ans = 0;
                } else if (res == 0) {
                    ans = get_size(g[v].first);
                } else {
                    ans = get_size(g[v].first) + get_size(g[v].second);
                }
                while (v != 0) {
                    if (type[v] == 0) {
                        if (tree1[par[v]] == -1) {
                            ans++;
                        }
                    } else {
                        ans += get_size(g[par[v]].first);
                        if (tree1[par[v]] != 1) {
                            ans++;
                        }
                    }
                    v = par[v];
                }
                cout << ans + 1 << '\n';
            }
        }
    }
}
